package api

import (
	"net/http"

	"github.com/gin-gonic/gin"

	"gitlab.33.cn/link33/sidecar/model/pb"
)

type API interface {
	SendTransaction()
	GetTransaction()
	GetBlockByHash()
	GetBlockByNumber()
	ListResources()
	Call()
}

const (
	SendTransaction  = "sendTransaction"
	GetTransaction   = "getTransaction"
	GetBlockByHash   = "getBlockByHash"
	GetBlockByNumber = "getBlockByNumber"
	ListResources    = "listResources"
	Call             = "call"
)

// POST 127.0.0.1:80/api/sendTransaction
func (g *Server) sendTransaction(c *gin.Context) {
	ibtp := &pb.IBTP{}
	var res pb.Response
	if err := c.BindJSON(ibtp); err != nil {
		res.Data = []byte(err.Error())
		c.JSON(http.StatusBadRequest, res)
		return
	}

	// TODO
	c.JSON(http.StatusOK, res)
	panic("implement me")
}

// GET 127.0.0.1:80/api/QueryOuterMeta/:did
func (g *Server) QueryOuterMeta(c *gin.Context) {
	did := c.Param("did")
	data := g.mg.AppChain(did).QueryOuterMeta()
	c.JSON(http.StatusOK, data)
}

// GET 127.0.0.1:80/api/QueryIBTP/:did/:to/:id
func (g *Server) QueryIBTP(c *gin.Context) {
	id := c.Param("id")
	to := c.Param("to")
	did := c.Param("did")
	ib, err := g.mg.AppChain(did).QueryIBTP(to, id)
	if err != nil {
		c.JSON(http.StatusOK, NewError(http.StatusOK, http.StatusInternalServerError, err.Error()))
	} else {
		c.JSON(http.StatusOK, ib)
	}
}

// GET 127.0.0.1:80/api/getTransaction/:hash
func (g *Server) getTransaction(c *gin.Context) {
	panic("implement me")
}

// GET 127.0.0.1:80/api/getBlockByHash/:hash
func (g *Server) getBlockByHash(c *gin.Context) {
	panic("implement me")
}

// GET 127.0.0.1:80/api/getBlockByNumber/:height
func (g *Server) getBlockByNumber(c *gin.Context) {
	panic("implement me")
}

// GET 127.0.0.1:80/api/listResources
func (g *Server) listResources(c *gin.Context) {
	panic("implement me")
}

// POST 127.0.0.1:80/api/call
func (g *Server) call(c *gin.Context) {
	panic("implement me")
}
